算法打卡day45|动态规划篇13| Leetcode 300.最长递增子序列、674. 最长连续递增序列、718. 最长重复子数组

算法题

Leetcode 300.最长递增子序列

题目链接:300.最长递增子序列

大佬视频讲解:300.最长递增子序列视频讲解

个人思路

没什么思路,菜就多练!

解法
动态规划

"子序列是由数组派生而来的序列,删除(或不删除)数组中的元素而不改变其余元素的顺序"。

子序列问题是动态规划解决的经典问题 ,当前下标i的递增子序列长度 ,其实和i之前的下标j的子序列长度有关系;

动规五部曲:

1.dpi的定义

dpi表示i之前包括i的以numsi结尾的最长递增子序列的长度

之所以表示 "以numsi结尾的最长递增子序" ,因为在 做 递增比较的时候,如果比较 numsj 和 numsi 的大小,那么两个递增子序列一定分别以numsj为结尾 和 numsi为结尾

2.状态转移方程

位置i的最长升序子序列等于j从0到i-1各个位置的最长升序子序列 + 1 的最大值。

所以:if (numsi > numsj)dpi = max(dpi, dpj + 1);

注意:这里不是要dpi 与 dpj + 1进行比较,而是要取dpj + 1的最大值。

3.dpi的初始化

每一个i,对应的dpi(即最长递增子序列)起始大小至少都是1.

4.确定遍历顺序

dpi 是有0到i-1各个位置的最长递增子序列 推导而来,那么遍历i 一定是从前向后遍历。

j其实就是遍历0到i-1,那么是从前到后,还是从后到前遍历都无所谓,只要把 0 到 i-1 的元素都遍历了就行了。 所以默认习惯 从前向后遍历。遍历i的循环在外层,遍历j则在内层

5.举例推导dp数组

输入:0,1,0,3,2,dp数组的变化如下:

​

java 复制代码
class Solution {
    public int lengthOfLIS(int[] nums) {
        int[] dp = new int[nums.length];
        int res = 1;
        Arrays.fill(dp, 1);//初始化数组初始值

        for (int i = 1; i < dp.length; i++) {
            for (int j = 0; j < i; j++) {
                if (nums[i] > nums[j]) {
                    dp[i] = Math.max(dp[i], dp[j] + 1);//找递增最大值
                }
                res = Math.max(res, dp[i]);//存取结果
            }
        }
        return res;
    }
}

时间复杂度:O( n^2**)**;(for嵌套遍历数组)

空间复杂度:O( n**);**(存储一个长度为n的dp数组)


Leetcode 674. 最长连续递增序列

题目链接:674. 最长连续递增序列

大佬视频讲解:674. 最长连续递增序列视频讲解

个人思路

这道题与上面那道题是类似的,甚至更简单,因为是找连续的递增序列大小,只用比较一前一后,所以不用嵌套for循环遍历,只用遍历i,一边遍历一边存取最大递增序列

解法
动态规划

动规五部曲:

1.确定dp数组(dp table)以及下标的含义

dpi:以下标i为结尾的连续递增的子序列长度为dpi。

注意这里的定义,一定是以下标i为结尾,并不是说一定以下标0为起始位置。

2.确定递推公式

如果 numsi > numsi - 1,那么以 i 为结尾的连续递增的子序列长度 一定等于以i - 1为结尾的连续递增的子序列长度 + 1。

即:dpi = dpi - 1 + 1;

因为本题要求连续递增子序列,所以就只要比较numsi与numsi - 1,而不用去比较numsj与numsi (j是在0到i之间遍历),因此本题一层for循环就行,比较numsi 和 numsi - 1。

3.dp数组如何初始化

以下标i为结尾的连续递增的子序列长度最少也应该是1 ,即就是numsi这一个元素。所以dpi应该初始1;

4.确定遍历顺序

从递推公式上可以看出, dpi + 1依赖dpi,所以一定是从前向后遍历。

5.举例推导dp数组

已输入nums = 1,3,5,4,7为例,dp数组状态如下:

java 复制代码
public static int findLengthOfLCIS(int[] nums) {
        int[] dp = new int[nums.length];
        for (int i = 0; i < dp.length; i++) {//初始化
            dp[i] = 1;
        }
        int res = 1;

        for (int i = 0; i < nums.length - 1; i++) {
            if (nums[i + 1] > nums[i]) {
                dp[i + 1] = dp[i] + 1;
            }
            res = res > dp[i + 1] ? res : dp[i + 1];//存储最长连续递增序列长度
        }
        return res;
    }

时间复杂度:O( n**)**;(遍历数组)

空间复杂度:O( n**);**(使用一个dp数组)


贪心法

这道题目也可以用贪心来做,思路为: 遇到numsi > numsi - 1的情况,count就++,否则count为1,记录count的最大值。

java 复制代码
public static int findLengthOfLCIS(int[] nums) {
    if (nums.length == 0) return 0;
    int res = 1; // 连续子序列最少也是1
    int count = 1;

    for (int i = 0; i < nums.length - 1; i++) {
        if (nums[i + 1] > nums[i]) { // 连续记录
            count++;
        } else { // 不连续,count从头开始
            count = 1;
        }
        if (count > res) res = count;//更新最长子序列长度
    }
    return res;
}

时间复杂度:O( n**)**;(遍历数组)

空间复杂度:O( 1**);**(无使用其他大的额外空间)


Leetcode 718. 最长重复子数组

题目链接:718. 最长重复子数组

大佬视频讲解:718. 最长重复子数组视频讲解

个人思路

这题是动态规划的经典题目,可以用二维数组来记录两个字符串的所有比较情况

解法
动态规划

动规五部曲:

1.确定dp数组(dp table)以及下标的含义

dpij :以下标i - 1为结尾的A,和以下标j - 1为结尾的B,最长重复子数组长度为dpij。

(特别注意: "以下标i - 1为结尾的A" 标明一定是 以Ai-1为结尾的字符串 )

2.确定递推公式

根据dpij的定义,dpij的状态只能由dpi - 1j - 1推导出来。

即当Ai - 1 和Bj - 1相等的时候,dpij = dpi - 1j - 1 + 1;

根据递推公式可以看出,遍历i 和 j 要从1开始!

3.dp数组如何初始化

根据dpij的定义,dpi0 和dp0j其实都是没有意义的!但dpi0 和dp0j要初始值 ,因为 为了方便递归公式dpij = dpi - 1j - 1 + 1;所以dpi0 和dp0j初始化为0。

举个例子:A0如果和B0相同的话,dp11 = dp00 + 1,只有dp00初始为0,正好符合递推公式逐步累加起来。

4.确定遍历顺序

外层for循环遍历A,内层for循环遍历B。都是从前往后遍历,并在遍历的时候顺便把dpij的最大值记录下来。

5.举例推导dp数组

拿示例1中,A: 1,2,3,2,1,B: 3,2,1,4,7为例,以下是dp数组的状态变化

​

java 复制代码
class Solution {
    public int findLength(int[] nums1, int[] nums2) {
        int result = 0;
        int[][] dp = new int[nums1.length + 1][nums2.length + 1];
        
        for (int i = 1; i < nums1.length + 1; i++) {//从1开始
            for (int j = 1; j < nums2.length + 1; j++) {
                if (nums1[i - 1] == nums2[j - 1]) {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                    result = Math.max(result, dp[i][j]);//保存最长重复数组长度
                }
            }
        }
        
        return result;
    }
}

时间复杂度:O( n*m**)**;(n 为nums1长度,m为nums2长度)

空间复杂度:O( n*m**);**(二维dp数组)


滚动数组

因为dpij都是由dpi - 1j - 1推出,那么压缩为一维数组,也就是dpj都是由dpj - 1推出。也就是相当于可以把上一层dpi - 1j拷贝到下一层dpij来继续用。

此时遍历B数组的时候,就要从后向前遍历,这样避免重复覆盖。

java 复制代码
class Solution {
    public int findLength(int[] nums1, int[] nums2) {
        int[] dp = new int[nums2.length + 1];
        int result = 0;

        for (int i = 1; i <= nums1.length; i++) {
            for (int j = nums2.length; j > 0; j--) {
                if (nums1[i - 1] == nums2[j - 1]) {
                    dp[j] = dp[j - 1] + 1;
                } else {
                    dp[j] = 0;
                }
                result = Math.max(result, dp[j]);
            }
        }
        return result;
    }
}

时间复杂度:O( n*m**)**;(n 为nums1长度,m为nums2长度)

空间复杂度:O( m**);**(一维dp数组)


以上是个人的思考反思与总结 ,若只想根据系列题刷,参考卡哥的网址代码随想录算法官网

相关推荐
Navigator_Z10 分钟前
LeetCode //C - 1301. Number of Paths with Max Score
c语言·算法·leetcode
Interview Aid11235 分钟前
Uber Interview Process 完整指南:面试流程、OA 真题与 VO 备考
面试·职场和发展
金銀銅鐵38 分钟前
[Java] 展示增删元素时 LinkedList 的内部变化
java·后端·ai编程
卡卡~~38 分钟前
“101计划”核心课程实践教材《数据实验结构指导-C++语言版》题目集
开发语言·c++·学习·算法
企业数字化笔记1 小时前
AI视频增强后画质怎么验收?插值基线、伪细节与帧间闪烁的检查方法
人工智能·算法·音视频
布吉岛的石头1 小时前
Java 程序员第 50 阶段3:数据工程:预训练语料清洗与去重
java·开发语言·人工智能·深度学习·transformer
大文说跨境1 小时前
防关联浏览器的指纹覆盖到什么程度:六类参数的实测与自检方法
java·指纹浏览器·tiktok运营
学逆向的2 小时前
C 内存属性
c语言·开发语言·算法·网络安全
Carol06302 小时前
上肢及肩肘关节
java·服务器·数据库